
const St = imports.gi.St;
const Main = imports.ui.main;
const Tweener = imports.ui.tweener;

const Gtk = imports.gi.Gtk;
const Panel = imports.ui.panel;
const PanelMenu = imports.ui.panelMenu;
const Me = imports.misc.extensionUtils.getCurrentExtension();
const Shell = imports.gi.Shell;
const Meta = imports.gi.Meta;
const Atk = imports.gi.Atk;
const Clutter = imports.gi.Clutter;
const Convenience = Me.imports.convenience;
const Gettext = imports.gettext.domain("kiran-show-desktop");
const _ = Gettext.gettext;

let text, button;
let indicatorBox, icon, _desktopShown, _alreadyMinimizedWindows, box, _settings, shouldrestore;
function _hidetip() {
    if(text && text.get_parent())
    {
        Tweener.addTween(text,
                     { opacity: 0,
                       time: 0.5,
                       transition: 'easeOutQuad'
                       });
        Main.uiGroup.remove_actor(text);
        text = null;
    }
}

function _showtip(actor) {
    if (!text) {
        text = new St.Label({style_class:"my-helloworld-label",text: _("Show Desktop") });
        Main.uiGroup.add_actor(text);
    }
    let [x,y]=actor.get_transformed_position();
    let [a,b]=text.get_transformed_size();
    text.opacity = 0;
    let monitor = Main.layoutManager.primaryMonitor;
    text.set_position(x-a+10,y-35);
    Tweener.addTween(text,
                     { opacity: 255,
                       time: 0.5,
                       transition: 'easeOutQuad'
                       });
}

function _getWindowToControl () {
    let win = global.display.focus_window,
    workspace = global.screen.get_active_workspace(),
    windows = workspace.list_windows().filter(function (w) {
        return w.get_window_type() !== Meta.WindowType.DESKTOP;
    });
    // BAH: list_windows() doesn't return in stackin order (I thought it did)
    windows = global.display.sort_windows_by_stacking(windows);

    if (win === null || win.get_window_type() === Meta.WindowType.DESKTOP) {
        // No windows are active, control the uppermost window on the
        // current workspace
        if (windows.length) {
            win = windows[windows.length - 1];
            if(!('get_maximized' in win)) {
                win = win.get_meta_window();
            }
        }
    }
    return win;
}

function _showDesktop() {
    let metaWorkspace = global.screen.get_active_workspace();
    let windows = metaWorkspace.list_windows();

    if (_desktopShown) {
        for ( let i = 0; i < windows.length; ++i ) {
            if (windows[i].minimized){
                shouldrestore = true;
                for (let j = 0; j < _alreadyMinimizedWindows.length; j++) {
                    if (windows[i] == _alreadyMinimizedWindows[j]) {
                        shouldrestore = false;
                        break;
                    }
                }
            if (shouldrestore) {
                //toggle icon to the opposite settings when windows are minimized
                //button.connect('enter-event', function() {
                //    _SetButtonIcon('hover');
                //});
                //button.connect('leave-event', function() {
                //    _SetButtonIcon('base');
                //});
                //only check and hide overview when button clicked durp durp
                if (Main.overview.visible) {
                    Main.overview.hide();
                }
                windows[i].unminimize(global.get_current_time());
                //activate and bring the last focused window to the top
                let win = _getWindowToControl();
                //find better method than current time as shell complains or did maybe a bug but i have no reference
                win.activate(global.get_current_time());
            }
        }
    }
    _alreadyMinimizedWindows.length = []; //Apparently this is better than this._alreadyMinimizedWindows = [];
    } else {
        for ( let i = 0; i < windows.length; ++i ) {
            if (!windows[i].skip_taskbar){
                if (!windows[i].minimized) {
                    //set dfault hover icon when no windows minimized
                    //button.connect('enter-event', function() {
                    //    _SetButtonIcon('base');
                   // });
                   // button.connect('leave-event', function() {
                     //   _SetButtonIcon('hover');
                   // });
                    //only check and hide overview when button clicked durp durp
                    if (Main.overview.visible) {
                        Main.overview.hide();
                    }
                    windows[i].minimize(global.get_current_time());
                } else {
                    _alreadyMinimizedWindows.push(windows[i]);
                }
            }
        }
    }
    _desktopShown = !_desktopShown;
}

function init() {
    Convenience.initTranslations("kiran-show-desktop");
    _desktopShown = false;
    _alreadyMinimizedWindows = [];
    button = new St.Bin({ style_class: 'panel-button',
                          reactive: true,
                          can_focus: true,
                          x_fill: true,
                          y_fill: false,
                          track_hover: true });
    let icon = new St.Icon({ icon_name: 'view-more-symbolic',
                             //style_class: 'system-status-icon' });
                             style_class: 'show-desktop-icon' });

    button.set_child(icon);
    button.connect('button-press-event', _showDesktop);
    button.connect('enter-event', _showtip);
    button.connect('leave-event', _hidetip);
}

function enable() {
    Main.panel._rightBox.insert_child_at_index(button, 9);
}

function disable() {
    Main.panel._rightBox.remove_child(button);
}
